package LeidenUniv.Tracking;

import java.io.*;
import java.util.*;
import ij.process.*;
import ij.IJ.*;
import ij.*;
import HomeMade.Tracking.*;
import ij.gui.*;
import ij.plugin.*; 
import java.lang.*;


public class Tracking_Configuration implements PlugIn {

	public void run(String arg) {
		SetConfiguration("TrackingConfiguration");
		String [] Config = GetConfiguration("TrackingConfiguration");
		//IJ.log(Config[1]);
	}

	public String[] SetConfiguration(String title) {
		String Pdir =IJ.getDirectory("plugins");// - Returns the path to the plugins directory.
		String[] coChoice={"High", "Low"};
		String[] bckChoice={"dark", "light"};
		String[] bckOption={"Manual", "Default", "Huang", "Intermodes", "IsoData", "Li", "MaxEntropy", "Mean", "MinError", "Minimum", "Moments", "Otsu", "Percentile", "RenyiEntropy", "Shanbag", "Triangle", "Yen"};
		String[] ColorOption={"Object","timed", "black", "cyan", "blue", "green", "yellow", "orange", "red", "magenta", "white","none"};
		String[] saChoice={"Yes", "No"};
		String[] muChoice={"Yes", "No"};
		int nz=1;
	        int objs=10;
	        int Mobjs=500;
		int TrL=10;
		int TrR=10;
		int GR=1;
		double MinC=0.5;
	
	        GenericDialog gd = new GenericDialog("Settings");
	
	        gd.addChoice("Light or dark background", bckChoice, bckChoice[0]);
	        gd.addChoice("Which thresholding method do you want to use", bckOption, bckOption[1]);
	        gd.addChoice("Select the color of your tracks", ColorOption, ColorOption[0]);
	
	        gd.addChoice("High or low signal to noise; cutoff=3", coChoice, coChoice[0]);
	        gd.addChoice("Do you want the detected foci saved as ROI file?", saChoice, saChoice[0]);
	        gd.addChoice("Do you want watershedding?", muChoice, muChoice[1]);
	
	        gd.addNumericField("minimum object size:", objs, 0);
	        gd.addNumericField("maximum object size:", Mobjs, 0);
	        gd.addNumericField("Set track range:", TrR, 0);
	        gd.addNumericField("Set gap range:", GR, 0);
	        gd.addNumericField("Set minimum circulartity:", MinC, 2);
	        gd.showDialog();
	
	        String bckSet=gd.getNextChoice();
	        String ThresholdSet=gd.getNextChoice();
	        String ColorSet=gd.getNextChoice();
	        String coSet=gd.getNextChoice();
	        String saSet=gd.getNextChoice();
	        String muSet=gd.getNextChoice();
	
	        objs=(int)gd.getNextNumber();
	        Mobjs=(int)gd.getNextNumber();
	        TrR=(int)gd.getNextNumber();
	        GR=(int)gd.getNextNumber();
		MinC=gd.getNextNumber();
		String [] Config=new String[11];
		try{
		    PrintWriter writer = new PrintWriter(Pdir+title+".cfg", "UTF-8");
		    writer.println("Background set at:"+bckSet);
		    Config[0]=""+bckSet;
		    writer.println("Thresholding method:"+ThresholdSet);
		    Config[1]=""+ThresholdSet;
		    writer.println("Tracking colors:"+ColorSet);
		    Config[2]=""+ColorSet;
		    writer.println("Noise cutoff:"+coSet);
		    Config[3]=""+coSet;
		    writer.println("Save Roi file:"+saSet);
		    Config[4]=""+saSet;
		    writer.println("Watershedding:"+muSet);
		    Config[5]=""+muSet;
		    writer.println("Minimum object size:"+objs);
		    Config[6]=""+objs;
		    writer.println("Maximum object size:"+Mobjs);
		    Config[7]=""+Mobjs;
		    writer.println("Track range:"+TrR);
		    Config[8]=""+TrR;
		    writer.println("Gap range:"+GR);
		    Config[9]=""+GR;
		    writer.println("Minimum circularity:"+MinC);
		    Config[10]=""+MinC;
		    writer.close();
		} catch (IOException e) {
		   // do something
		   IJ.showMessage("Currently unable to write the configuration\nPlease try again after restarting imageJ");
		}
		return Config;
	}

	public String[] GetConfiguration(String title){
		String Pdir =IJ.getDirectory("plugins");
		ArrayList<String> configList = new ArrayList<String>();
		try {
			BufferedReader BR = new BufferedReader(new FileReader(Pdir+title+".cfg"));
    		String line = BR.readLine();
		    while (line != null) {
		    	configList.add(line);
		    	line = BR.readLine();
		    }
		} catch (FileNotFoundException ex){ 
			IJ.log("There is no configuration, creating a configuration");
			String [] Config = new String[11];
			Config = SetConfiguration(title);
			return Config;
		} catch (Exception e){
			IJ.log(e.toString());	
		} finally {
		}
		
		String [] Config = new String[configList.size()];
		for (int a=0;a<configList.size();a++){
			Config[a]=configList.get(a).substring(configList.get(a).indexOf(":")+1);
			IJ.log(configList.get(a));
		}
		return Config;
	}
}
