package LeidenUniv.Tracking;

import ij.text.*;
import ij.IJ.*;
import ij.*;
import ij.measure.ResultsTable;
import ij.gui.*;
import ij.io.OpenDialog;
import ij.plugin.HyperStackConverter;
import ij.plugin.filter.ParticleAnalyzer;
import ij.process.*;
import java.util.*;
import ij.plugin.frame.*;

public class focidetection0517 {
   
    static ImagePlus imp;
    static ResultsTable rt = ResultsTable.getResultsTable();
    static RoiManager roiMan = RoiManager.getInstance();
    public static int nz;
    public static int nt;
    public static int TrL;
    public static int TrR, GR;
    public int Sizeinframes;
    public int B;
    public static int objs, Mobjs;
    public static int numobj;
    public static double MinC;
    public static double[] AreaArray;
    public static double[] XMArray;
    public static double[] YMArray;
    public static double[] SlideArray;
    public static Roi[] RoiArray;

    public static data run() {
        IJ.run("Close All", "");
        OpenDialog od = new OpenDialog("Open Image", "");
        Calendar cur= Calendar.getInstance();
        IJ.log("Started at "+cur.getTime());
        String directory = od.getDirectory();
        String name = od.getFileName();
        String path = directory+name;
        imp = IJ.openImage(path);

	imp.show();
	
        imp = WindowManager.getCurrentImage();
        imp.hide();
		
        int nDeep=imp.getNSlices();
        int nTimes=imp.getNFrames();
        int impID = imp.getID();
        if (imp.getNChannels()>1 || nDeep >1 && nTimes>1){
        	IJ.log("This tracking plugin was developped for 2-dimensional, 1-channel images.\nPlugin is stopping");
        	return null;
        }
        nz=1;
        objs=10;
	TrL=10;
	TrR=10;
	TrR=10;
	GR=1;
	MinC=0.5;
	Tracking_Configuration TR = new Tracking_Configuration();
	String [] Config = TR.GetConfiguration("TrackingConfiguration");
	//IJ.log(Arrays.toString(Config));
        String bckSet=Config[0];
        String ThresholdSet=Config[1];
        String ColorSet=Config[2];
        String coSet=Config[3];
        String saSet=Config[4];
        String muSet=Config[5];
        objs=Integer.parseInt(Config[6]);
        Mobjs=Integer.parseInt(Config[7]);
        TrR=Integer.parseInt(Config[8]);
        GR=Integer.parseInt(Config[9]);
	MinC=Double.parseDouble(Config[10]);
	
        int Sizeinframes = imp.getNSlices(); //47
        //IJ.run(imp, "Set Scale...", "distance=0 known=0 pixel=1 unit=pixel");
        IJ.run(imp, "8-bit", "");
        IJ.run(imp, "Set Measurements...", "area center stack redirect=None decimal=5");
        if (coSet.equals("Low")){
            IJ.run(imp, "Enhance Contrast", "saturated=0.35 stack");
            IJ.run(imp, "Apply LUT", "stack");
        };
        for (int B=0; B<5;B++){
            IJ.run(imp, "Gaussian Blur...", "sigma=1 stack");
        };
        if (coSet.equals("High")){
            IJ.run(imp, "Convolve...", "text1=[0 0 -1 -1 -1 0 0\n0 -1 -1 -1 -1 -1 0\n-1 -1 3 3 3 -1 -1\n-1 -1 3 4 3 -1 -1\n-1 -1 3 3 3 -1 -1\n0 -1 -1 -1 -1 -1 0\n0 0 -1 -1 -1 0 0\n] normalize stack");
            if (ThresholdSet.equals("Manual")){
            	imp.show();
		IJ.run("Threshold...");
	            new WaitForUserDialog("Please press ok after adjusting threshold.").show();
 	    } else {
		IJ.setAutoThreshold(imp, ""+ThresholdSet+" "+bckSet +"");
	    }
		//imp.hide();
        };

        if (coSet.equals("Low")){
            if (ThresholdSet.equals("Manual")){
		IJ.run("Threshold...");
	            new WaitForUserDialog("Please press ok after adjusting threshold.").show();
		} else {
			IJ.setAutoThreshold(imp, ""+ThresholdSet+" "+bckSet +"");
		}
        };

	IJ.run(imp, "Options...", "iterations=1 count=1 black edm=Overwrite do=Nothing");
        IJ.run(imp, "Convert to Mask", "method=Default background=Dark black");
        if (muSet.equals("Yes")){
        	IJ.run(imp, "Watershed", "stack");
        }
        
        ImageProcessor ip = imp.getProcessor();
        //IJ.run("ROI Manager...", "");
        if (roiMan==null) {
        	roiMan = new RoiManager();
        } else {
        	roiMan.close();
        	roiMan = new RoiManager();
        }
        
        rt = ResultsTable.getResultsTable();
        rt.reset();
        ParticleAnalyzer PA = new ParticleAnalyzer(2049,1056833 ,rt, objs, Mobjs, MinC, 1.0);
        PA.setRoiManager(roiMan);
        for (int ss=0;ss<Math.max(nDeep,nTimes);ss++){
        	imp.setSlice(ss+1);
        	PA.analyze(imp,ip);	
        }
        TextWindow tw= rt.getResultsWindow();
	if (!(tw==null)){
		tw.setVisible(false);
	}
	// here we make the heat map of cells
	int[] dim = imp.getDimensions();
	int max = Math.max(dim[3],dim[4]);
	IJ.run(imp, "Z Project...", "start=1 stop="+max+ " projection=[Average Intensity]");
	ImagePlus Heat = IJ.getImage();
	Heat.hide();
	IJ.run(Heat, "Fire", "");
	IJ.run(Heat, "Enhance Contrast", "saturated=0.00");

	Heat.setTitle("Heat map cells");
	IJ.saveAs(Heat, "Tiff", directory+"\\HeatMap.tif");
	
        imp = IJ.openImage(path);
        imp.show();
        imp.getWindow().setVisible(false);
        //imp = WindowManager.getCurrentImage();
        //IJ.run(imp, "Set Scale...", "distance=0 known=0 pixel=1 unit=pixel");
        Roi[] rois=roiMan.getRoisAsArray();
        numobj = rois.length;
        
        AreaArray=new double[numobj];
        XMArray=new double[numobj];
        YMArray=new double[numobj];
        SlideArray=new double[numobj];
        RoiArray=new Roi [numobj];
        
        roiMan.runCommand("Sort");
        for  (int B=0; B<numobj; B++){
            roiMan.select(imp, B);
            roiMan.runCommand("Measure");
            AreaArray[B]=rt.getValue("Area",B);
            XMArray[B]=rt.getValue("XM",B);
            YMArray[B]=rt.getValue("YM",B);
            RoiArray[B]=roiMan.getSelectedRoisAsArray()[0];
            if (nDeep>nTimes){
		SlideArray[B]=rt.getValue("Slice",B);
            } else {
            	SlideArray[B]=rt.getValue("Slice",B);
            }
            	
        }
        
if (saSet.equals("Yes")){
        	roiMan.runCommand("Save", directory+"\\RoiSet.zip");	
        }
        roiMan.runCommand("Deselect");
        roiMan.runCommand("Delete");
        roiMan.close();
        IJ.log("Detection done!");
        data Data = new data(AreaArray, XMArray, YMArray, SlideArray, ColorSet, imp, directory, TrR, GR, RoiArray);
        return Data;
        
    }
}
