package HomeMade.Tracking;

import ij.text.*;
import ij.IJ.*;
import ij.*;
import ij.measure.ResultsTable;
import ij.gui.*;
import ij.io.OpenDialog;
import ij.plugin.HyperStackConverter;
import ij.plugin.filter.ParticleAnalyzer;
import ij.process.*;


import ij.plugin.frame.RoiManager;

public class focidetectionJoost {
   
    static ImagePlus imp;
    static ResultsTable rt = ResultsTable.getResultsTable();
    static RoiManager roiMan = RoiManager.getInstance();
    public static int nz;
    public static int nt;
    public static int TrL;
    public static int TrR, GR;
    public int Sizeinframes;
    public int B;
    public static int objs;
    public static int numobj;
    static String[] coChoice={"High", "Low"};
    static String[] bckChoice={"dark", "light"};
    static String[] bckOption={"Manual", "Default", "Huang", "Intermodes", "IsoData", "Li", "MaxEntropy", "Mean", "MinError", "Minimum", "Moments", "Otsu", "Percentile", "RenyiEntropy", "Shanbag", "Triangle", "Yen"};
    static String[] ColorOption={"Object","timed", "black", "cyan", "blue", "green", "yellow", "orange", "red", "magenta", "white","none"};
    static String[] saChoice={"Yes", "No"};
    static String[] muChoice={"Yes", "No"};
    public static double[] AreaArray;
    public static double[] XMArray;
    public static double[] YMArray;
    public static double[] SlideArray;
    public static double MinC;

    public static data run() {
        IJ.run("Close All", "");
        OpenDialog od = new OpenDialog("Open Image", "");
        String directory = od.getDirectory();
        String name = od.getFileName();
        String path = directory+name;
        imp = IJ.openImage(path);

	imp.show();
	
        imp = WindowManager.getCurrentImage();
        imp.hide();
        int nDeep=imp.getNSlices();
        int nTimes=imp.getNFrames();
        int impID = imp.getID();
	

        nz=1;
        objs=10;
	TrL=10;
	TrR=10;
	TrR=10;
	GR=1;
	MinC=0.5;

        GenericDialog gd = new GenericDialog("Settings");

        gd.addChoice("Light or dark background", bckChoice, bckChoice[0]);
        gd.addChoice("Which thresholding method do you want to use", bckOption, bckOption[1]);
        gd.addChoice("Select the color of your tracks", ColorOption, ColorOption[0]);

        gd.addChoice("High or low signal to noise; cutoff=3", coChoice, coChoice[0]);
        gd.addChoice("Do you want the detected foci saved as ROI file?", saChoice, saChoice[0]);
        gd.addChoice("Do you want watershedding?", muChoice, muChoice[1]);

        gd.addNumericField("Expected minimum object size:", objs, 0);
        gd.addNumericField("Set track range:", TrR, 0);
        gd.addNumericField("Set gap range:", GR, 0);
        gd.addNumericField("Set minimum circulartity:", MinC, 2);
        gd.showDialog();

        String bckSet=gd.getNextChoice();
        String ThresholdSet=gd.getNextChoice();
        String ColorSet=gd.getNextChoice();
        String coSet=gd.getNextChoice();
        String saSet=gd.getNextChoice();
        String muSet=gd.getNextChoice();

        objs=(int)gd.getNextNumber();
        TrR=(int)gd.getNextNumber();
        GR=(int)gd.getNextNumber();

	MinC=gd.getNextNumber();

        int Sizeinframes = imp.getNSlices(); //47
        //IJ.run(imp, "Set Scale...", "distance=0 known=0 pixel=1 unit=pixel");
        IJ.run(imp, "8-bit", "");
        IJ.run(imp, "Set Measurements...", "area center stack redirect=None decimal=5");
        if (coSet == "Low"){
            IJ.run(imp, "Enhance Contrast", "saturated=0.35 stack");
            IJ.run(imp, "Apply LUT", "stack");
        };
        for (int B=0; B<5;B++){
            IJ.run(imp, "Gaussian Blur...", "sigma=1 stack");
        };

        if (coSet == "High"){
            IJ.run(imp, "Convolve...", "text1=[0 0 -1 -1 -1 0 0\n0 -1 -1 -1 -1 -1 0\n-1 -1 3 3 3 -1 -1\n-1 -1 3 4 3 -1 -1\n-1 -1 3 3 3 -1 -1\n0 -1 -1 -1 -1 -1 0\n0 0 -1 -1 -1 0 0\n] normalize stack");
            if (ThresholdSet=="Manual"){
            	imp.show();
		IJ.run("Threshold...");
	            new WaitForUserDialog("Please press ok after adjusting threshold.").show();
		} else {
		IJ.setAutoThreshold(imp, ""+ThresholdSet+" "+bckSet +"");
		}
		//imp.hide();
        };

        if (coSet == "Low"){
            if (ThresholdSet=="Manual"){
		IJ.run("Threshold...");
	            new WaitForUserDialog("Please press ok after adjusting threshold.").show();
		} else {
			IJ.setAutoThreshold(imp, ""+ThresholdSet+" "+bckSet +"");
		}
        };

	IJ.run(imp, "Options...", "iterations=1 count=1 black edm=Overwrite do=Nothing");
        IJ.run(imp, "Convert to Mask", "method=Default background=Dark black");
        if (muSet=="Yes"){
        	IJ.run(imp, "Watershed", "stack");
        }
        
        ImageProcessor ip = imp.getProcessor();
        //IJ.run("ROI Manager...", "");
        if (roiMan==null) {
        	roiMan = new RoiManager();
        } else {
        	roiMan.close();
        	roiMan = new RoiManager();
        }
        
        rt = ResultsTable.getResultsTable();
        rt.reset();
        ParticleAnalyzer PA = new ParticleAnalyzer(2049,1056833 ,rt, objs, 500, MinC, 1.0);
        PA.setRoiManager(roiMan);
        for (int ss=0;ss<Math.max(nDeep,nTimes);ss++){
        	imp.setSlice(ss+1);
        	PA.analyze(imp,ip);	
        }
        TextWindow tw= rt.getResultsWindow();
	if (!(tw==null)){
		tw.setVisible(false);
	}
        imp = IJ.openImage(path);
        imp.show();
        imp.getWindow().setVisible(false);
        //imp = WindowManager.getCurrentImage();
        //IJ.run(imp, "Set Scale...", "distance=0 known=0 pixel=1 unit=pixel");
        Roi[] rois=roiMan.getRoisAsArray();
        numobj = rois.length;
        
        AreaArray=new double[numobj];
        XMArray=new double[numobj];
        YMArray=new double[numobj];
        SlideArray=new double[numobj];
        
        roiMan.runCommand("Sort");
        for  (int B=0; B<numobj; B++){
            roiMan.select(imp, B);
            roiMan.runCommand("Measure");
            AreaArray[B]=rt.getValue("Area",B);
            XMArray[B]=rt.getValue("XM",B);
            YMArray[B]=rt.getValue("YM",B);
            if (nDeep>nTimes){
		SlideArray[B]=rt.getValue("Slice",B);
            } else {
            	SlideArray[B]=rt.getValue("Slice",B);
            }
            	
        }
        
if (saSet=="Yes"){
        	roiMan.runCommand("Save", directory+"\\RoiSet.zip");	
        }
        IJ.log("Detection done!");
        data Data = new data(AreaArray, XMArray, YMArray, SlideArray, ColorSet, imp, directory, TrR, GR);
        
        rt.getResultsWindow().setVisible(true);
        return Data;
        
    }
}
